package analyzer

import "git.tebibyte.media/sashakoshka/fspl/entity"

var primitiveTypes = map[string] entity.Type {
	"Int":  &entity.TypeWord  { Signed: true             },
	"UInt": &entity.TypeWord  {                          },
	"I8":   &entity.TypeInt   { Signed: true,  Width: 8  },
	"I16":  &entity.TypeInt   { Signed: true,  Width: 16 },
	"I32":  &entity.TypeInt   { Signed: true,  Width: 32 },
	"I64":  &entity.TypeInt   { Signed: true,  Width: 64 },
	"U8":   &entity.TypeInt   { Signed: false, Width: 8  },
	"U16":  &entity.TypeInt   { Signed: false, Width: 16 },
	"U32":  &entity.TypeInt   { Signed: false, Width: 32 },
	"U64":  &entity.TypeInt   { Signed: false, Width: 64 },
	"F32":  &entity.TypeFloat {                Width: 32 },
	"F64":  &entity.TypeFloat {                Width: 32 },
}

var builtinTypes = map[string] entity.Type { }

var builtinConsts = map[string] struct { } {
	"true":  struct { } { },
	"false": struct { } { },
}

func init () {
	builtinTypes["Byte"] = &entity.TypeInt { Signed: false, Width: 8  }
	builtinTypes["Bool"] = &entity.TypeInt { Signed: false, Width: 8  }
	builtinTypes["Rune"] = &entity.TypeInt { Signed: false, Width: 32 }
	builtinTypes["String"] = &entity.TypeSlice {
		Element: &entity.TypeNamed {
			Name: "Byte",
			Type: builtinTypes["Byte"],
		},
	}
}
